"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MySet = (function () {
    function MySet() {
        this.collection = [];
    }
    MySet.prototype.has = function (el) {
        return this.collection.indexOf(el, 0) !== -1;
    };
    MySet.prototype.values = function () {
        return this.collection;
    };
    MySet.prototype.add = function (el) {
        if (this.has(el)) {
            return false;
        }
        else {
            this.collection.push(el);
            return true;
        }
    };
    MySet.prototype.size = function () {
        return this.collection.length;
    };
    MySet.prototype.remove = function (el) {
        if (this.has(el)) {
            var index = this.collection.indexOf(el);
            this.collection.splice(index, 1);
            return true;
        }
        else {
            return false;
        }
    };
    MySet.prototype.union = function (otherSet) {
        var unionSet = new Set();
        var firstSet = this.values();
        var secondSet = otherSet.values();
        firstSet.forEach(function (el) { return unionSet.add(el); });
        secondSet.forEach(function (el) { return unionSet.add(el); });
        return unionSet;
    };
    MySet.prototype.intersection = function (otherSet) {
        var intersection = new Set();
        var first = this.values();
        first.forEach(function (el) {
            if (otherSet.has(el)) {
                intersection.add(el);
            }
        });
        return intersection;
    };
    MySet.prototype.difference = function (otherSet) {
        var difference = new Set();
        var first = this.values();
        first.forEach(function (el) {
            if (!otherSet.has(el)) {
                difference.add(el);
            }
        });
        return difference;
    };
    MySet.prototype.subset = function (otherSet) {
        var first = this.values();
        return first.every(function (value) {
            return otherSet.has(value);
        });
    };
    return MySet;
}());
exports.MySet = MySet;
//# sourceMappingURL=MySet.js.map