"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var Broadcast = (function () {
    function Broadcast() {
        this._listener = [];
    }
    Object.defineProperty(Broadcast.prototype, "quantity", {
        get: function () {
            return this._listener.length;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Broadcast.prototype, "isEmpty", {
        get: function () {
            return this.quantity === 0;
        },
        enumerable: true,
        configurable: true
    });
    Broadcast.prototype.add = function (listener) {
        this._listener.push(listener);
    };
    Broadcast.prototype.remove = function (listener) {
        for (var i = 0; i < this._listener.length; i++) {
            if (this._listener[i] === listener) {
                this._listener.splice(i, 1);
            }
        }
    };
    Broadcast.prototype.clear = function () {
        this._listener = [];
    };
    Broadcast.prototype.send = function (data) {
        var e_1, _a;
        try {
            for (var _b = __values(this._listener), _c = _b.next(); !_c.done; _c = _b.next()) {
                var item = _c.value;
                item(data);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    return Broadcast;
}());
exports.broadcast = new Broadcast();
//# sourceMappingURL=Broadcast.js.map