"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var EventBus = (function () {
    function EventBus() {
        this.observersMap = new Map();
    }
    EventBus.remove = function (observers, fn) {
        for (var i = 0; i < observers.length; i++) {
            if (fn(observers[i])) {
                observers.splice(i, 1);
            }
        }
    };
    EventBus.prototype.publish = function (eventType, data) {
        try {
            this.observersMap.get(eventType).forEach(function (el) { return el.notify(data); });
        }
        catch (e) {
            console.error("@Param<eventType>错误,未注册的事件: " + eventType);
        }
    };
    EventBus.prototype.registerObserver = function (eventType, observer) {
        if (this.observersMap.get(eventType)) {
            this.observersMap.get(eventType).push(observer);
        }
        else {
            this.observersMap.set(eventType, []);
            this.observersMap.get(eventType).push(observer);
        }
    };
    EventBus.prototype.unSubscribe = function (eventType, observer) {
        try {
            EventBus.remove(this.observersMap.get(eventType), function (el) { return el === observer; });
        }
        catch (e) {
            console.error("@Param<eventType>错误,未注册的事件:" + eventType);
        }
    };
    return EventBus;
}());
exports.eventBus = new EventBus();
//# sourceMappingURL=EventBus.js.map