"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var BaseMap = (function () {
    function BaseMap() {
        this._data = Object.create(null);
        this._length = 0;
    }
    Object.defineProperty(BaseMap.prototype, "length", {
        get: function () {
            return this._length;
        },
        enumerable: true,
        configurable: true
    });
    BaseMap.prototype.clear = function () {
        this._data = Object.create(null);
        this._length = 0;
    };
    BaseMap.prototype.remove = function (key) {
        delete this._data[key];
    };
    BaseMap.prototype.has = function (key) {
        for (var _key in this._data) {
            if (_key === key) {
                return true;
            }
        }
        return false;
    };
    BaseMap.prototype.get = function (key) {
        return this._data[key];
    };
    BaseMap.prototype.set = function (key, value) {
        if (this.has(key)) {
            this._data[key] = value;
        }
        else {
            this._data[key] = value;
            this._length++;
        }
    };
    return BaseMap;
}());
exports.BaseMap = BaseMap;
//# sourceMappingURL=BaseMap.js.map