"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ListNode = (function () {
    function ListNode(args) {
        this.val = 0;
        this.next = null;
        if (typeof args === "number") {
            this.val = args;
        }
        else {
            this.initialize(args);
        }
    }
    ListNode.prototype.deleteNode = function (node) {
        if (this.next === null) {
            return;
        }
        var compare = true;
        while (compare) {
            if (this.next.val === node.val) {
                this.next = this.next.next;
                compare = false;
            }
        }
    };
    ListNode.prototype.toString = function () {
        var res = "[";
        var current = this;
        while (current !== null) {
            res += current.val + ",";
            current = current.next;
        }
        res = res.slice(0, res.length - 1) + "]";
        return res;
    };
    ListNode.prototype.initialize = function (nums) {
        if (nums.length === 0) {
            throw new Error("not allowed empty array");
        }
        this.val = nums[0];
        var current = this;
        for (var i = 1; i < nums.length; i++) {
            current.next = new ListNode(nums[i]);
            current = current.next;
        }
    };
    return ListNode;
}());
exports.ListNode = ListNode;
//# sourceMappingURL=ListNode.js.map