"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var Node_1 = require("./Node");
var NumberNode = (function (_super) {
    __extends(NumberNode, _super);
    function NumberNode(id, data, parentId) {
        var _this = _super.call(this) || this;
        _this.id = id;
        _this.data = data;
        _this.parentId = parentId ? parentId : null;
        _this.children = [];
        _this.isRoot = function () { return _this.parentId === null; };
        return _this;
    }
    return NumberNode;
}(Node_1.BaseNode));
var NodeManage = (function () {
    function NodeManage() {
        this._list = [];
    }
    NodeManage.prototype.addElement = function (el) {
        if (el.parentId === null) {
            this._list.push(el);
        }
        else {
            var res = this._insertByParentId(el, this._list);
            if (res === null) {
                throw new Error(el.parentId + " is not in collection");
            }
        }
    };
    NodeManage.prototype.findById = function (id) {
        this._findById(id, this._list);
    };
    NodeManage.prototype._findById = function (id, list) {
        var e_1, _a;
        try {
            for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                var item = list_1_1.value;
                if (item.id === id) {
                    return item;
                }
                if (item.children.length > 0) {
                    this._findById(id, item.children);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (list_1_1 && !list_1_1.done && (_a = list_1.return)) _a.call(list_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return null;
    };
    NodeManage.prototype._insertByParentId = function (el, list) {
        var e_2, _a;
        try {
            for (var list_2 = __values(list), list_2_1 = list_2.next(); !list_2_1.done; list_2_1 = list_2.next()) {
                var item = list_2_1.value;
                if (item.id === el.parentId) {
                    item.children.push(el);
                    return el;
                }
                if (item.children.length > 0) {
                    this._insertByParentId(el, item.children);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (list_2_1 && !list_2_1.done && (_a = list_2.return)) _a.call(list_2);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return null;
    };
    return NodeManage;
}());
//# sourceMappingURL=Node.test.js.map