"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function loadScript(url, attr) {
    return new Promise(function (resolve, reject) {
        if (document.scripts.some(function (script) { return script.src === url; })) {
            resolve();
        }
        else {
            var script = document.createElement("script");
            if (attr) {
                for (var key in attr) {
                    script.setAttribute(key, attr[key]);
                }
            }
            script.type = "text/javascript";
            script.src = url;
            script.onload = resolve;
            script.onerror = reject;
            document.body.appendChild(script);
        }
    });
}
exports.loadScript = loadScript;
//# sourceMappingURL=loadScript.js.map